| Flutter Impeller |

Public Member Functions | List of all members
impeller::RoundRectGeometry Class Referencefinal

A Geometry class that generates fillable vertices (with or without texture coordinates) directly from a round rect object with uniform radii at every corner. More...

`#include <round_rect_geometry.h>`

Inheritance diagram for impeller::RoundRectGeometry:

## Public Member Functions
| RoundRectGeometry (const Rect &bounds, const Size &radii)
| ~RoundRectGeometry () override
bool | CoversArea (const Matrix &transform, const Rect &rect) const override
| Determines if this geometry, transformed by the given `transform`, will completely cover all surface area of the given `rect`. More...
bool | IsAxisAlignedRect () const override
Public Member Functions inherited from impeller::Geometry
virtual | ~Geometry ()
virtual GeometryResult::Mode | GetResultMode () const
virtual bool | CanApplyMaskFilter () const
virtual Scalar | ComputeAlphaCoverage (const Matrix &transform) const

## Additional Inherited Members
Static Public Member Functions inherited from impeller::Geometry
static std::unique_ptr< Geometry > | MakeFillPath (const flutter::DlPath &path, std::optional< Rect > inner_rect=std::nullopt)
static std::unique_ptr< Geometry > | MakeStrokePath (const flutter::DlPath &path, const StrokeParameters &stroke={})
static std::unique_ptr< Geometry > | MakeCover ()
static std::unique_ptr< Geometry > | MakeRect (const Rect &rect)
static std::unique_ptr< Geometry > | MakeOval (const Rect &rect)
static std::unique_ptr< Geometry > | MakeLine (const Point &p0, const Point &p1, const StrokeParameters &stroke)
static std::unique_ptr< Geometry > | MakeCircle (const Point &center, Scalar radius)
static std::unique_ptr< Geometry > | MakeStrokedCircle (const Point &center, Scalar radius, Scalar stroke_width)
static std::unique_ptr< Geometry > | MakeFilledArc (const Rect &oval_bounds, Degrees start, Degrees sweep, bool include_center)
static std::unique_ptr< Geometry > | MakeStrokedArc (const Rect &oval_bounds, Degrees start, Degrees sweep, const StrokeParameters &stroke)
static std::unique_ptr< Geometry > | MakeRoundRect (const Rect &rect, const Size &radii)
static std::unique_ptr< Geometry > | MakeRoundSuperellipse (const Rect &rect, Scalar corner_radius)
static Scalar | ComputeStrokeAlphaCoverage (const Matrix &entity, Scalar stroke_width)
| Compute an alpha value to simulate lower coverage of fractional pixel strokes. More...
static GeometryResult | ComputePositionGeometry (const ContentContext &renderer, const Tessellator::VertexGenerator &generator, const Entity &entity, RenderPass &pass)

## Detailed Description

A Geometry class that generates fillable vertices (with or without texture coordinates) directly from a round rect object with uniform radii at every corner.

Generating vertices for a stroked ellipse would require a lot more work since the line width must be applied perpendicular to the distorted ellipse shape.

See also
  |FillRoundRectGeometry|
  |StrokeRoundRectGeometry|

Definition at line 25 of file round_rect_geometry.h.

## Constructor & Destructor Documentation

## ◆ RoundRectGeometry()

impeller::RoundRectGeometry::RoundRectGeometry | ( | const Rect & | bounds,
|  | const Size & | radii
| ) |  |
| explicit

Definition at line 9 of file round_rect_geometry.cc.

10 : bounds_(bounds), radii_(radii) {}

## ◆ ~RoundRectGeometry()

impeller::RoundRectGeometry::~RoundRectGeometry | ( |  | ) |
| overridedefault

## Member Function Documentation

## ◆ CoversArea()

bool impeller::RoundRectGeometry::CoversArea | ( | const Matrix & | transform,
|  | const Rect & | rect
| ) |  | const
| overridevirtual

Determines if this geometry, transformed by the given `transform`, will completely cover all surface area of the given `rect`.

This is a conservative estimate useful for certain optimizations.

Returns
  `true` if the transformed geometry is guaranteed to cover the given `rect`. May return `false` in many undetected cases where the transformed geometry does in fact cover the `rect`.

Reimplemented from impeller::Geometry.

Definition at line 29 of file round_rect_geometry.cc.

30 {
31 if (!transform.IsTranslationScaleOnly()) {
32 return false;
33 }
34 bool flat_on_tb = bounds_.GetWidth() > radii_.width * 2;
35 bool flat_on_lr = bounds_.GetHeight() > radii_.height * 2;
36 if (!flat_on_tb && !flat_on_lr) {
37 return false;
38 }
39 // We either transform the bounds and delta-transform the radii,
40 // or we compute the vertical and horizontal bounds and then
41 // transform each. Either way there are 2 transform operations.
42 // We could also get a weaker answer by computing just the
43 // "inner rect" and only doing a coverage analysis on that,
44 // but this process will produce more culling results.
45 if (flat_on_tb) {
46 Rect vertical_bounds = bounds_.Expand(Size{-radii_.width, 0});
47 Rect coverage = vertical_bounds.TransformBounds(transform);
48 if (coverage.Contains(rect)) {
49 return true;
50 }
51 }
52 if (flat_on_lr) {
53 Rect horizontal_bounds = bounds_.Expand(Size{0, -radii_.height});
54 Rect coverage = horizontal_bounds.TransformBounds(transform);
55 if (coverage.Contains(rect)) {
56 return true;
57 }
58 }
59 return false;
60 }
transform
Matrix transform
Definition: gaussian_blur_filter_contents.cc:312
impeller::Rect
TRect< Scalar > Rect
Definition: rect.h:788
impeller::Size
TSize< Scalar > Size
Definition: size.h:159
impeller::TRect::Expand
constexpr TRect< T > Expand(T left, T top, T right, T bottom) const
Returns a rectangle with expanded edges. Negative expansion results in shrinking.
Definition: rect.h:618
impeller::TRect::TransformBounds
constexpr TRect TransformBounds(const Matrix &transform) const
Creates a new bounding box that contains this transformed rectangle.
Definition: rect.h:472
impeller::TRect::GetHeight
constexpr Type GetHeight() const
Returns the height of the rectangle, equivalent to |GetSize().height|.
Definition: rect.h:347
impeller::TRect::GetWidth
constexpr Type GetWidth() const
Returns the width of the rectangle, equivalent to |GetSize().width|.
Definition: rect.h:341
impeller::TSize::height
Type height
Definition: size.h:29
impeller::TSize::width
Type width
Definition: size.h:28

References impeller::TRect< T >::Contains(), impeller::TRect< T >::Expand(), impeller::TRect< T >::GetHeight(), impeller::TRect< T >::GetWidth(), impeller::TSize< T >::height, transform, impeller::TRect< T >::TransformBounds(), and impeller::TSize< T >::width.

## ◆ IsAxisAlignedRect()

bool impeller::RoundRectGeometry::IsAxisAlignedRect | ( |  | ) | const
| overridevirtual

Reimplemented from impeller::Geometry.

Definition at line 62 of file round_rect_geometry.cc.

62 {
63 return false;
64 }

The documentation for this class was generated from the following files:

- impeller/entity/geometry/round_rect_geometry.h
- impeller/entity/geometry/round_rect_geometry.cc